require 'rest-client'
require 'json'
require_relative '../domain/application_config.rb'

class UserWidgetService
    @@own_widgets_url = 'https://showoff-rails-react-production.herokuapp.com/api/v1/users/me/widgets'
    @@widgets_by_user_id_url ='https://showoff-rails-react-production.herokuapp.com/api/v1/users/'
      
       def self.get_private_widgets(bearer_token)
         return RestClient::Request.execute(method: :get, url: @@own_widgets_url, 
            headers: {'Content-Type': 'application/json', params: {:client_id => ApplicationConfig.get_client_id, :client_secret => ApplicationConfig.get_client_secret}, 
            'Authorization': bearer_token})
        end

        def self.get_private_widgets_with_search_term(search_term, bearer_token)
            return RestClient::Request.execute(method: :get, url: @@own_widgets_url, 
               headers: {'Content-Type': 'application/json', params: {:client_id => ApplicationConfig.get_client_id, :client_secret => ApplicationConfig.get_client_secret, :term => search_term}, 
               'Authorization': bearer_token})
        end

        def self.get_widgets_by_user_id(user_id, bearer_token)
            url_with_id = @@widgets_by_user_id_url + "#{user_id}" + "/widgets"
            return RestClient::Request.execute(method: :get, url: url_with_id, 
               headers: {'Content-Type': 'application/json', params: {:client_id => ApplicationConfig.get_client_id, :client_secret => ApplicationConfig.get_client_secret}, 
               'Authorization': bearer_token})
        end

        def self.get_widgets_by_user_id_with_search_term(user_id, search_term, bearer_token)
            url_with_id = @@widgets_by_user_id_url + "#{user_id}" + "/widgets"
            return RestClient::Request.execute(method: :get, url: url_with_id, 
               headers: {'Content-Type': 'application/json', params: {:client_id => ApplicationConfig.get_client_id, :client_secret => ApplicationConfig.get_client_secret, :term => search_term}, 
               'Authorization': bearer_token})
        end

end

